Index: src/UIElements/QT4/QTDialog.cpp
===================================================================
--- src/UIElements/QT4/QTDialog.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/UIElements/QT4/QTDialog.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,5 +6,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "UIElements/QT4/QTDialog.hpp"
+
+#include <boost/lexical_cast.hpp>
 
 #include <string>
@@ -17,7 +24,10 @@
 #include <QtGui/QDoubleSpinBox>
 #include <Qt/qlineedit.h>
+#include <Qt/qlistwidget.h>
 #include <Qt/qdialogbuttonbox.h>
 #include <Qt/qpushbutton.h>
 #include <Qt/qcombobox.h>
+
+#include <boost/lexical_cast.hpp>
 
 #include "Helpers/MemDebug.hpp"
@@ -28,5 +38,8 @@
 #include "element.hpp"
 #include "molecule.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
 #include "Descriptors/MoleculeIdDescriptor.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Box.hpp"
 
 
@@ -83,56 +96,86 @@
 }
 
-void QTDialog::queryBoolean(char const*, bool*,string){
+void QTDialog::queryBoolean(char const*,string){
   // TODO
   ASSERT(false, "Not implemented yet");
 }
 
-void QTDialog::queryAtom(char const*, atom**, string){
+void QTDialog::queryAtom(char const*, string){
   // TODO
   ASSERT(false, "Not implemented yet");
 }
 
-void QTDialog::queryBox(char const*, double**, string){
+void QTDialog::queryAtoms(char const*, string){
   // TODO
   ASSERT(false, "Not implemented yet");
 }
 
-
-void QTDialog::queryInt(const char *title, int *target,string)
-{
-  registerQuery(new IntQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryDouble(const char* title, double* target,string){
-  registerQuery(new DoubleQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryString(const char* title, std::string *target,string)
-{
-  registerQuery(new StringQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryStrings(const char* title, std::vector<std::string> *target,string)
-{
-  registerQuery(new StringsQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryMolecule(const char *title,molecule **target,string)
-{
-  registerQuery(new MoleculeQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check,string) {
-  registerQuery(new VectorQTQuery(title,target,cellSize,check,inputLayout,this));
-}
-
-void QTDialog::queryElement(const char* title, std::vector<element *> *target,string){
-  registerQuery(new ElementQTQuery(title,target,inputLayout,this));
+void QTDialog::queryBox(char const*, string){
+  // TODO
+  ASSERT(false, "Not implemented yet");
+}
+
+
+void QTDialog::queryInt(const char *title,string)
+{
+  registerQuery(new IntQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryInts(const char *title,string)
+{
+  registerQuery(new IntsQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryDouble(const char* title,string){
+  registerQuery(new DoubleQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryDoubles(const char* title,string){
+  registerQuery(new DoublesQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryString(const char* title,string)
+{
+  registerQuery(new StringQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryStrings(const char* title,string)
+{
+  registerQuery(new StringsQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryMolecule(const char *title,string)
+{
+  registerQuery(new MoleculeQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryMolecules(const char *title,string)
+{
+  // TODO
+  ASSERT(false, "Not implemented yet");
+}
+
+void QTDialog::queryVector(const char* title, bool check,string) {
+  registerQuery(new VectorQTQuery(title,check,inputLayout,this));
+}
+
+void QTDialog::queryVectors(const char* title, bool check,string) {
+  // TODO
+  ASSERT(false, "Not implemented yet");
+}
+
+void QTDialog::queryElement(const char* title, string){
+  registerQuery(new ElementQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryElements(const char* title, string){
+  // TODO
+  ASSERT(false, "Not implemented yet");
 }
 
 /************************** Query Objects *******************************/
 
-QTDialog::IntQTQuery::IntQTQuery(string _title,int *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::IntQuery(_title,_target),
+QTDialog::IntQTQuery::IntQTQuery(string _title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::IntQuery(_title),
     parent(_parent)
 {
@@ -155,12 +198,58 @@
 }
 
-// Handling is easy since the GUI makes it impossible to enter invalid values
-bool QTDialog::IntQTQuery::handle()
-{
-  return true;
-}
-
-QTDialog::DoubleQTQuery::DoubleQTQuery(string title,double *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::DoubleQuery(title,_target),
+bool QTDialog::IntQTQuery::handle() {
+  return true;
+}
+
+
+QTDialog::IntsQTQuery::IntsQTQuery(string _title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::IntsQuery(_title),
+    parent(_parent)
+{
+  QHBoxLayout * thisHLayout = new QHBoxLayout();
+  QVBoxLayout * thisV1Layout = new QVBoxLayout();
+  QVBoxLayout * thisV2Layout = new QVBoxLayout();
+
+  QLabel *titleLabel = new QLabel(QString(getTitle().c_str()));
+  QLabel *inputLabel = new QLabel("Enter to add");
+  QListWidget* inputList = new QListWidget();
+  inputList->setSelectionMode(QAbstractItemView::ExtendedSelection);
+  QLineEdit* inputBox = new QLineEdit();
+  inputLabel->setBuddy(inputBox);
+  titleLabel->setBuddy(inputList);
+  QPushButton* AddButton = new QPushButton("Add");
+  AddButton->setEnabled(false);
+  QPushButton* RemoveButton = new QPushButton("Remove");
+  RemoveButton->setEnabled(false);
+
+  thisV1Layout->addWidget(titleLabel);
+  thisV1Layout->addWidget(inputList);
+  thisV2Layout->addWidget(inputLabel);
+  thisV2Layout->addWidget(inputBox);
+  thisV2Layout->addWidget(AddButton);
+  thisV2Layout->addWidget(RemoveButton);
+  parent->addLayout(thisHLayout);
+  thisHLayout->addLayout(thisV1Layout);
+  thisHLayout->addLayout(thisV2Layout);
+
+  pipe = new QTQueryListPipe<int>(&tmp,_dialog,inputBox,inputList,AddButton,RemoveButton);
+  connect(inputBox,SIGNAL(textChanged(const QString&)),pipe,SLOT(IntegerEntered(const QString&)));
+  connect(inputList,SIGNAL(itemSelectionChanged()),pipe,SLOT(IntegerSelected()));
+  connect(AddButton,SIGNAL(Clicked()),pipe,SLOT(AddValue()));
+  connect(RemoveButton,SIGNAL(Clicked()),pipe,SLOT(RemoveRow()));
+}
+
+QTDialog::IntsQTQuery::~IntsQTQuery()
+{
+  delete pipe;
+}
+
+bool QTDialog::IntsQTQuery::handle() {
+  return true;
+}
+
+
+QTDialog::DoubleQTQuery::DoubleQTQuery(string title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::DoubleQuery(title),
     parent(_parent)
 {
@@ -190,6 +279,52 @@
 
 
-QTDialog::StringQTQuery::StringQTQuery(string _title,string *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::StringQuery(_title,_target),
+QTDialog::DoublesQTQuery::DoublesQTQuery(string title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::DoublesQuery(title),
+    parent(_parent)
+{
+  QHBoxLayout * thisHLayout = new QHBoxLayout();
+  QVBoxLayout * thisV1Layout = new QVBoxLayout();
+  QVBoxLayout * thisV2Layout = new QVBoxLayout();
+
+  QLabel *titleLabel = new QLabel(QString(getTitle().c_str()));
+  QLabel *inputLabel = new QLabel("Enter to add");
+  QListWidget* inputList = new QListWidget();
+  inputList->setSelectionMode(QAbstractItemView::ExtendedSelection);
+  QLineEdit* inputBox = new QLineEdit();
+  inputLabel->setBuddy(inputBox);
+  titleLabel->setBuddy(inputList);
+  QPushButton* AddButton = new QPushButton("Add");
+  AddButton->setEnabled(false);
+  QPushButton* RemoveButton = new QPushButton("Remove");
+  RemoveButton->setEnabled(false);
+
+  thisV1Layout->addWidget(titleLabel);
+  thisV1Layout->addWidget(inputList);
+  thisV2Layout->addWidget(inputLabel);
+  thisV2Layout->addWidget(inputBox);
+  thisV2Layout->addWidget(AddButton);
+  thisV2Layout->addWidget(RemoveButton);
+  parent->addLayout(thisHLayout);
+  thisHLayout->addLayout(thisV1Layout);
+  thisHLayout->addLayout(thisV2Layout);
+
+  pipe = new QTQueryListPipe<double>(&tmp,_dialog,inputBox,inputList,AddButton,RemoveButton);
+  connect(inputBox,SIGNAL(textChanged(const QString&)),pipe,SLOT(IntegerEntered(const QString&)));
+  connect(inputList,SIGNAL(itemSelectionChanged()),pipe,SLOT(IntegerSelected()));
+  connect(AddButton,SIGNAL(Clicked()),pipe,SLOT(AddValue()));
+  connect(RemoveButton,SIGNAL(Clicked()),pipe,SLOT(RemoveRow()));}
+
+QTDialog::DoublesQTQuery::~DoublesQTQuery()
+{
+  delete pipe;
+}
+
+bool QTDialog::DoublesQTQuery::handle() {
+  return true;
+}
+
+
+QTDialog::StringQTQuery::StringQTQuery(string _title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::StringQuery(_title),
     parent(_parent)
 {
@@ -217,19 +352,39 @@
 }
 
-QTDialog::StringsQTQuery::StringsQTQuery(string _title,vector<string> *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::StringsQuery(_title,_target),
-    parent(_parent)
-{
-  thisLayout = new QHBoxLayout();
-  titleLabel = new QLabel(QString(getTitle().c_str()));
-  inputBox = new QLineEdit();
-  parent->addLayout(thisLayout);
-  thisLayout->addWidget(titleLabel);
-  thisLayout->addWidget(inputBox);
-
-  pipe = new StringQTQueryPipe(&temp,_dialog);
-  pipe->update(inputBox->text());
-  connect(inputBox,SIGNAL(textChanged(const QString&)),pipe,SLOT(update(const QString&)));
-}
+QTDialog::StringsQTQuery::StringsQTQuery(string _title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::StringsQuery(_title),
+    parent(_parent)
+{
+  QHBoxLayout * thisHLayout = new QHBoxLayout();
+  QVBoxLayout * thisV1Layout = new QVBoxLayout();
+  QVBoxLayout * thisV2Layout = new QVBoxLayout();
+
+  QLabel *titleLabel = new QLabel(QString(getTitle().c_str()));
+  QLabel *inputLabel = new QLabel("Enter to add");
+  QListWidget* inputList = new QListWidget();
+  inputList->setSelectionMode(QAbstractItemView::ExtendedSelection);
+  QLineEdit* inputBox = new QLineEdit();
+  inputLabel->setBuddy(inputBox);
+  titleLabel->setBuddy(inputList);
+  QPushButton* AddButton = new QPushButton("Add");
+  AddButton->setEnabled(false);
+  QPushButton* RemoveButton = new QPushButton("Remove");
+  RemoveButton->setEnabled(false);
+
+  thisV1Layout->addWidget(titleLabel);
+  thisV1Layout->addWidget(inputList);
+  thisV2Layout->addWidget(inputLabel);
+  thisV2Layout->addWidget(inputBox);
+  thisV2Layout->addWidget(AddButton);
+  thisV2Layout->addWidget(RemoveButton);
+  parent->addLayout(thisHLayout);
+  thisHLayout->addLayout(thisV1Layout);
+  thisHLayout->addLayout(thisV2Layout);
+
+  pipe = new QTQueryListPipe<std::string>(&tmp,_dialog,inputBox,inputList,AddButton,RemoveButton);
+  connect(inputBox,SIGNAL(textChanged(const QString&)),pipe,SLOT(IntegerEntered(const QString&)));
+  connect(inputList,SIGNAL(itemSelectionChanged()),pipe,SLOT(IntegerSelected()));
+  connect(AddButton,SIGNAL(Clicked()),pipe,SLOT(AddValue()));
+  connect(RemoveButton,SIGNAL(Clicked()),pipe,SLOT(RemoveRow()));}
 
 QTDialog::StringsQTQuery::~StringsQTQuery()
@@ -255,6 +410,6 @@
 }
 
-QTDialog::MoleculeQTQuery::MoleculeQTQuery(string _title, molecule **_target, QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::MoleculeQuery(_title,_target),
+QTDialog::MoleculeQTQuery::MoleculeQTQuery(string _title, QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::MoleculeQuery(_title),
     parent(_parent)
 {
@@ -291,11 +446,44 @@
 }
 
-QTDialog::VectorQTQuery::VectorQTQuery(std::string title, Vector *_target, const double *const _cellSize, bool _check,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::VectorQuery(title,_target,_cellSize,_check),
-    parent(_parent)
-{
-  // About the j: I don't know why it was done this way, but it was used this way in Vector::AskPosition, so I reused it
-  int j = -1;
-  const char *coords[3] = {"x:","y:","z:"};
+QTDialog::MoleculesQTQuery::MoleculesQTQuery(string _title, QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::MoleculesQuery(_title),
+    parent(_parent)
+{
+  thisLayout = new QHBoxLayout();
+  titleLabel = new QLabel(QString(getTitle().c_str()));
+  inputBox = new QComboBox();
+  // add all molecules to the combo box
+  vector<molecule*> molecules = World::getInstance().getAllMolecules();
+  for(vector<molecule*>::iterator iter  = molecules.begin();
+      iter != molecules.end();
+      ++iter) {
+    stringstream sstr;
+    sstr << (*iter)->IndexNr << "\t" << (*iter)->getName();
+    inputBox->addItem(QString(sstr.str().c_str()),QVariant((*iter)->IndexNr));
+  }
+  parent->addLayout(thisLayout);
+  thisLayout->addWidget(titleLabel);
+  thisLayout->addWidget(inputBox);
+
+  pipe = new MoleculesQTQueryPipe(&tmp,_dialog,inputBox);
+  pipe->update(inputBox->currentIndex());
+  connect(inputBox,SIGNAL(currentIndexChanged(int)),pipe,SLOT(update(int)));
+}
+
+QTDialog::MoleculesQTQuery::~MoleculesQTQuery()
+{
+  delete pipe;
+}
+
+// Handling is easy, since the GUI makes it impossible to select invalid values
+bool QTDialog::MoleculesQTQuery::handle()
+{
+  return true;
+}
+
+QTDialog::VectorQTQuery::VectorQTQuery(std::string title, bool _check,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::VectorQuery(title,_check),
+    parent(_parent)
+{
   mainLayout= new QHBoxLayout();
   titleLabel = new QLabel(QString(getTitle().c_str()));
@@ -303,19 +491,16 @@
   subLayout = new QVBoxLayout();
   mainLayout->addLayout(subLayout);
-  for(int i=0; i<3; i++) {
-    j+=i+1;
-    coordLayout[i] = new QHBoxLayout();
-    subLayout->addLayout(coordLayout[i]);
-    coordLabel[i] = new QLabel(QString(coords[i]));
-    coordLayout[i]->addWidget(coordLabel[i]);
-    coordInput[i] = new QDoubleSpinBox();
-    coordInput[i]->setRange(0,cellSize[j]);
-    coordInput[i]->setDecimals(3);
-    coordLayout[i]->addWidget(coordInput[i]);
-    pipe[i] = new DoubleQTQueryPipe(&((*tmp)[i]),_dialog);
-    pipe[i]->update(coordInput[i]->value());
-    connect(coordInput[i],SIGNAL(valueChanged(double)),pipe[i],SLOT(update(double)));
-
-  }
+  QComboBox* inputBox = new QComboBox();
+  coordLayout = new QHBoxLayout();
+  subLayout->addLayout(coordLayout);
+  coordLabel = new QLabel(QString("x,y,z"));
+  coordLayout->addWidget(coordLabel);
+  coordInput = new QDoubleSpinBox();
+//  coordInput->setRange(0,M.at(i,i));
+  coordInput->setDecimals(3);
+  coordLayout->addWidget(coordInput);
+  pipe = new VectorQTQueryPipe(&(tmp),_dialog,inputBox);
+  //pipe->update(coordInput->value());
+  connect(coordInput,SIGNAL(valueChanged(double)),pipe,SLOT(update(double)));
   parent->addLayout(mainLayout);
 }
@@ -329,6 +514,38 @@
 
 
-QTDialog::ElementQTQuery::ElementQTQuery(std::string _title, vector<element *> *_target, QBoxLayout *_parent, QTDialog *_dialog) :
-    Dialog::ElementQuery(_title,_target),
+QTDialog::VectorsQTQuery::VectorsQTQuery(std::string title, bool _check,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::VectorsQuery(title,_check),
+    parent(_parent)
+{
+  mainLayout= new QHBoxLayout();
+  titleLabel = new QLabel(QString(getTitle().c_str()));
+  mainLayout->addWidget(titleLabel);
+  subLayout = new QVBoxLayout();
+  mainLayout->addLayout(subLayout);
+  QComboBox* inputBox = new QComboBox();
+  coordLayout = new QHBoxLayout();
+  subLayout->addLayout(coordLayout);
+  coordLabel = new QLabel(QString("x,y,z"));
+  coordLayout->addWidget(coordLabel);
+  coordInput = new QDoubleSpinBox();
+//  coordInput->setRange(0,M.at(i,i));
+  coordInput->setDecimals(3);
+  coordLayout->addWidget(coordInput);
+  pipe = new VectorsQTQueryPipe(&(tmp),_dialog,inputBox);
+  //pipe->update(coordInput->value());
+  connect(coordInput,SIGNAL(valueChanged(double)),pipe,SLOT(update(double)));
+  parent->addLayout(mainLayout);
+}
+
+QTDialog::VectorsQTQuery::~VectorsQTQuery()
+{}
+
+bool QTDialog::VectorsQTQuery::handle() {
+  return true;
+}
+
+
+QTDialog::ElementQTQuery::ElementQTQuery(std::string _title, QBoxLayout *_parent, QTDialog *_dialog) :
+    Dialog::ElementQuery(_title),
     parent(_parent)
 {
@@ -342,5 +559,5 @@
   {
     stringstream sstr;
-    sstr << (*iter).first << "\t" << (*iter).second->name;
+    sstr << (*iter).first << "\t" << (*iter).second->getName();
     inputBox->addItem(QString(sstr.str().c_str()),QVariant((*iter).first));
   }
@@ -349,5 +566,5 @@
   thisLayout->addWidget(inputBox);
 
-  pipe = new ElementQTQueryPipe(&elements,_dialog,inputBox);
+  pipe = new ElementQTQueryPipe(&tmp,_dialog,inputBox);
   pipe->update(inputBox->currentIndex());
   connect(inputBox,SIGNAL(currentIndexChanged(int)),pipe,SLOT(update(int)));
@@ -363,5 +580,108 @@
 }
 
+
+QTDialog::ElementsQTQuery::ElementsQTQuery(std::string _title, QBoxLayout *_parent, QTDialog *_dialog) :
+    Dialog::ElementsQuery(_title),
+    parent(_parent)
+{
+  periodentafel *periode = World::getInstance().getPeriode();
+  thisLayout = new QHBoxLayout();
+  titleLabel = new QLabel(QString(getTitle().c_str()));
+  inputBox = new QComboBox();
+  for(periodentafel::const_iterator iter = periode->begin();
+      iter!=periode->end();
+      ++iter)
+  {
+    stringstream sstr;
+    sstr << (*iter).first << "\t" << (*iter).second->getName();
+    inputBox->addItem(QString(sstr.str().c_str()),QVariant((*iter).first));
+  }
+  parent->addLayout(thisLayout);
+  thisLayout->addWidget(titleLabel);
+  thisLayout->addWidget(inputBox);
+
+  pipe = new ElementsQTQueryPipe(&tmp,_dialog,inputBox);
+  pipe->update(inputBox->currentIndex());
+  connect(inputBox,SIGNAL(currentIndexChanged(int)),pipe,SLOT(update(int)));
+}
+
+QTDialog::ElementsQTQuery::~ElementsQTQuery()
+{
+  delete pipe;
+}
+
+bool QTDialog::ElementsQTQuery::handle(){
+  return true;
+}
+
 /*************************** Plumbing *******************************/
+
+
+template<typename T> QTQueryListPipe<T>::QTQueryListPipe(std::vector<T> *_content, QTDialog *_dialog, QLineEdit *_inputBox, QListWidget *_inputList, QPushButton *_AddButton, QPushButton *_RemoveButton) :
+  content(_content),
+  dialog(_dialog),
+  inputBox(_inputBox),
+  inputList(_inputList),
+  AddButton(_AddButton),
+  RemoveButton(_RemoveButton)
+{}
+
+template<typename T> QTQueryListPipe<T>::~QTQueryListPipe()
+{}
+
+template<typename T> void QTQueryListPipe<T>::IntegerEntered(const QString&)
+{
+  AddButton->setEnabled(true);
+}
+
+template<typename T> void QTQueryListPipe<T>::IntegerSelected()
+{
+  if (inputList->selectedItems().empty())
+    RemoveButton->setEnabled(false);
+  else
+    RemoveButton->setEnabled(true);
+}
+
+template<typename T> void QTQueryListPipe<T>::AddInteger() {
+  // type-check
+  std::string text = inputBox->text().toStdString();
+  int number = 0;
+  try {
+    number = boost::lexical_cast<int>(text);
+  } catch (boost::bad_lexical_cast&) {
+    return;
+  };
+  // add item to both
+  inputList->addItem(QString(number));
+  AddValue(number);
+}
+
+template<typename T> void QTQueryListPipe<T>::AddValue(T item) {
+  content->push_back(item);
+
+  dialog->update();
+}
+
+template<typename T> void QTQueryListPipe<T>::RemoveInteger() {
+  QList<QListWidgetItem *> items = inputList->selectedItems();
+  for (QList<QListWidgetItem *>::iterator iter = items.begin(); !items.empty(); iter = items.begin()) {
+    // obtain which position item has (by making it current item)
+    inputList->setCurrentItem(*iter);
+    // remove
+    QTQueryListPipe<T>::RemoteRow(inputList->currentRow()); // template parameters needs to be known, such that compiler knows which to call
+    inputList->removeItemWidget(*iter);
+  }
+}
+
+template<typename T> void QTQueryListPipe<T>::RemoveRow(int row) {
+  int counter = 0;
+  typename std::vector<T>::iterator iter = content->begin();
+  for (; iter != content->end(); ++iter)
+    if (counter++ == row)
+      break;
+  if (iter != content->end())
+      content->erase(iter);
+}
+
 
 StringQTQueryPipe::StringQTQueryPipe(string *_content, QTDialog *_dialog) :
@@ -403,4 +723,66 @@
   dialog->update();
 }
+
+VectorQTQueryPipe::VectorQTQueryPipe(Vector *_content, QTDialog *_dialog, QComboBox *_theBox) :
+  content(_content),
+  dialog(_dialog),
+  theBox(_theBox)
+{}
+
+VectorQTQueryPipe::~VectorQTQueryPipe()
+{}
+
+void VectorQTQueryPipe::update() {
+  dialog->update();
+}
+
+VectorsQTQueryPipe::VectorsQTQueryPipe(std::vector<Vector> *_content, QTDialog *_dialog, QComboBox *_theBox) :
+  content(_content),
+  dialog(_dialog),
+  theBox(_theBox)
+{}
+
+VectorsQTQueryPipe::~VectorsQTQueryPipe()
+{}
+
+void VectorsQTQueryPipe::update() {
+  dialog->update();
+}
+
+AtomQTQueryPipe::AtomQTQueryPipe(atom **_content, QTDialog *_dialog, QComboBox *_theBox) :
+  content(_content),
+  dialog(_dialog),
+  theBox(_theBox)
+{}
+
+AtomQTQueryPipe::~AtomQTQueryPipe()
+{}
+
+void AtomQTQueryPipe::update(int newIndex) {
+  QVariant data = theBox->itemData(newIndex);
+  int idx = data.toInt();
+  (*content) = World::getInstance().getAtom(AtomById(idx));
+  dialog->update();
+}
+
+
+AtomsQTQueryPipe::AtomsQTQueryPipe(std::vector<atom *>*_content, QTDialog *_dialog, QComboBox *_theBox) :
+  content(_content),
+  dialog(_dialog),
+  theBox(_theBox)
+{}
+
+AtomsQTQueryPipe::~AtomsQTQueryPipe()
+{}
+
+void AtomsQTQueryPipe::update(int newIndex) {
+  QVariant data = theBox->itemData(newIndex);
+  int idx = data.toInt();
+  atom *Walker = World::getInstance().getAtom(AtomById(idx));
+  if (Walker)
+    (*content).push_back(Walker) ;
+  dialog->update();
+}
+
 
 MoleculeQTQueryPipe::MoleculeQTQueryPipe(molecule **_content, QTDialog *_dialog, QComboBox *_theBox) :
@@ -420,11 +802,28 @@
 }
 
-ElementQTQueryPipe::ElementQTQueryPipe(std::vector<element *> *_content, QTDialog *_dialog, QComboBox *_theBox) :
+
+MoleculesQTQueryPipe::MoleculesQTQueryPipe(std::vector<molecule *>*_content, QTDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
   theBox(_theBox)
-{
-  content->resize(1);
-}
+{}
+
+MoleculesQTQueryPipe::~MoleculesQTQueryPipe()
+{}
+
+void MoleculesQTQueryPipe::update(int newIndex) {
+  QVariant data = theBox->itemData(newIndex);
+  int idx = data.toInt();
+  molecule *mol = World::getInstance().getMolecule(MoleculeById(idx));
+  if (mol)
+    (*content).push_back(mol);
+  dialog->update();
+}
+
+ElementQTQueryPipe::ElementQTQueryPipe(const element **_content, QTDialog *_dialog, QComboBox *_theBox) :
+  content(_content),
+  dialog(_dialog),
+  theBox(_theBox)
+{}
 
 ElementQTQueryPipe::~ElementQTQueryPipe()
@@ -434,6 +833,25 @@
   QVariant data = theBox->itemData(newIndex);
   int idx = data.toInt();
-  (*content)[0] = World::getInstance().getPeriode()->FindElement(idx);
-  dialog->update();
-}
-
+  *content = World::getInstance().getPeriode()->FindElement(idx);
+  dialog->update();
+}
+
+ElementsQTQueryPipe::ElementsQTQueryPipe(std::vector<const element *>*_content, QTDialog *_dialog, QComboBox *_theBox) :
+  content(_content),
+  dialog(_dialog),
+  theBox(_theBox)
+{}
+
+ElementsQTQueryPipe::~ElementsQTQueryPipe()
+{}
+
+void ElementsQTQueryPipe::update(int newIndex) {
+  QVariant data = theBox->itemData(newIndex);
+  int idx = data.toInt();
+  const element *elemental = World::getInstance().getPeriode()->FindElement(idx);
+  if(elemental)
+    (*content).push_back(elemental);
+  dialog->update();
+}
+
+
